package jp.gr.java_conf.matsubara.expresser;

import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Boolean;
import jp.gr.java_conf.matsubara.expresser.type._Double;
import jp.gr.java_conf.matsubara.expresser.type._String;

/**
 * ^ϊsC^[tFCXłB<br/>
 * 
 * 쐬: 2005/05/22
 * 
 * @author m.matsubara
 */

public interface ITypeConverter {
    public IExpObject toPrimitive(RuntimeData runtime, IExpObject value) throws ExpException;
    public _Boolean toBoolean(RuntimeData runtime, IExpObject value) throws ExpException;
    public _Double toNumber(RuntimeData runtime, IExpObject value) throws ExpException;
    public _String toString(RuntimeData runtime, IExpObject value) throws ExpException;
    public IExpObject toObject(RuntimeData runtime, IExpObject value) throws ExpException;
}
