package jp.gr.java_conf.matsubara.expresser.type;

import java.util.List;

import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;


/**
 * _lIuWFNgłB<br/>
 * <br/>
 * 쐬: 2005/05/03
 * 
 * @author m.matsubara
 */

public class ExpBoolean extends _Boolean {
    public static IExpObject constructor = null; 

    private ExpObject object = null;
    
    private static ExpObject prototype = null;
    
    public ExpBoolean(boolean value) throws ExpException {
        super(value);
        object = new ExpObject("Boolean", constructor);
        object.setThisPrototype(getPrototype());
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#deleteProperty(java.lang.Integer)
     */
    public IExpObject deleteProperty(Integer id) throws ExpException {
        return object.deleteProperty(id);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getConstructorList()
     */
    public List getConstructorList() {
        return object.getConstructorList();
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(int)
     */
    public IExpObject getProperty(int index) throws ExpException {
        return object.getProperty(index);
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        return object.getProperty(id);
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(int, java.lang.Object)
     */
    public void putProperty(int index, IExpObject value) throws ExpException {
        object.putProperty(index, value);
    }
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#putProperty(java.lang.Integer, java.lang.Object)
     */
    public void putProperty(Integer id, IExpObject value) throws ExpException {
        object.putProperty(id, value);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(java.lang.Integer)
     */
    public IVariable getVariable(Integer id) {
        //  nbVIuWFNgoĕԂȂ̂́AhNXputPropertyI[o[ChĂ\邽߁B
        return new ExpObjectMember(this, id);
    }
    
    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getVariable(int)
     */
    public IVariable getVariable(int index) {
        return object.getVariable(index);  
    }
    
    /* (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#enumProperty()
     */
    public Integer[] enumProperty() {
        return object.enumProperty();
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
        }
        return prototype;
    }
}
