package jp.gr.java_conf.matsubara.expresser.type;

import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.property.Function__apply;
import jp.gr.java_conf.matsubara.expresser.type.property.Function__call;

/**
 * ֐IuWFNg̊NXłB<br/>
 * ۃNXɂȂĂ̂ŁAhNXIFunctionŒ`郁\bhȂ΂Ȃ܂B<br/>
 * <br/>
 * 쐬: 2005/05/24
 * 
 * @author m.matsubara
 */

public abstract class ExpFunctionBase extends ExpObject implements IFunction {
    /** toStringŎgp֐̖̂ł */
    private String functionName;
    /** toStringŎgp֐̖{̂ł */
    private String functionBody;
    /** length vpeB̒l */
    private int length;
    
    private static ExpObject prototype = null;
    
    private static final Integer propertyId$length = StringToId.toId("length");

    /**
     * ֐IuWFNg\z܂B
     * @param functionName ֐
     * @param functionBody ֐{
     * @param length ̐
     * @throws ExpException
     */
    public ExpFunctionBase(String functionName, String functionBody, int length) throws ExpException {
        super();
        this.functionName = functionName;
        this.functionBody = functionBody;
        this.length = length;
        //  super.constructorList.add();    //  ǉׂNXȂc
        setThisPrototype(getPrototype());
    }
    
    /**
     * ֐IuWFNg\z܂B
     * @param functionName ֐
     * @param length ̐
     * @throws ExpException
     */
    public ExpFunctionBase(String functionName, int length) throws ExpException {
        this(functionName, "", length);
        this.functionBody = "[Native code: " + this.getClass().getName() + "]";
    }
    
    /*
     *  ( Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return "function " + functionName + "([" + getLength() + " arguments]) { " + functionBody + " }";
    }
    
    /**
     * ̐Ԃ܂B 
     * @return ̐
     */
    public int getLength() {
        return this.length;
    }
    

    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#getProperty(java.lang.Integer)
     */
    public IExpObject getProperty(Integer id) throws ExpException {
        if (id.intValue() == propertyId$length.intValue())
            return new _Double(getLength());
        return super.getProperty(id);
    }
    
    /*
     *  (non-Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IExpObject#isProperty(java.lang.Integer, boolean)
     */
    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        if (id.intValue() == propertyId$length.intValue())
            return true;
        else
            return super.isProperty(id, searchPrototype);
    }
    
    
    
    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static synchronized ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
            prototype.putProperty(Function__apply.ID, Function__apply.getInstance());
            prototype.putProperty(Function__call.ID,  Function__call.getInstance());
        }
        return prototype;
    }
}
