package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IArray;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;


/**
 * Array^ pop() \bhłB<br/>
 * <br/>
 * 쐬: 2005/05/08
 * 
 * @author m.matsubara
 */

public class Array__pop extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("pop");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Array__pop() throws ExpException {
        super("pop", 0);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        IArray value = (IArray)thisObject;
        
        int length = value.length();
        if (length == 0)
            return Expresser.UNDEFINED;
        IExpObject result = value.getProperty(length - 1);
        value.setLength(length - 1);
        return result;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Array__pop();
        return instance;
    }
}
