package jp.gr.java_conf.matsubara.expresser.type.property;

import java.util.Date;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpDate;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;
import jp.gr.java_conf.matsubara.expresser.type._Double;


/**
 * DateIuWFNg parse() \bhłB<br/>
 * <br/>
 * 쐬: 2005/06/03
 * 
 * @author m.matsubara
 */

public class _Date__parse extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("parse");
    private static IExpObject instance = null;
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private _Date__parse() throws ExpException {
        super("parse", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        if (arguments.length < 1)
            return new _Double(Expresser.NaN);

        //  p[^̉
        String source = arguments[0].toString();
        
        Date date = ExpDate.parse(source);
        if (date != null)
            return new _Double(date.getTime());
        else
            return new _Double(Expresser.NaN);
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new _Date__parse();
        return instance;
    }
}
