package jp.gr.java_conf.matsubara.expresser.type;

import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;

/**
 * G[ێNXłB<br/>
 * <br/>
 * 쐬: 2005/05/01
 * 
 * @author m.matsubara
 */
public class ExpError extends ExpObject {
    public static IExpObject constructor = null; 

    private static ExpObject prototype = null;

    private static final Integer property$message = StringToId.toId("message");

    public ExpError(Object message) throws ExpException {
        super("Error", constructor);
        putProperty(property$message, (_String)message);
        setThisPrototype(getPrototype());
    }

    /**
     * prototype擾܂B
     * @return prototype 
     * @throws ExpException
     */
    public static ExpObject getPrototype() throws ExpException {
        if (prototype == null) {
            prototype = new ExpObject(ExpObject.getPrototype());
        }
        return prototype;
    }
    
    public String toString() {
        try {
            Object message = getProperty(property$message);
/*
            if (message instanceof IExpObject) {
                Object object = ((IExpObject)message).getProperty(StringToId.toId("toString"));
                if (object instanceof IFunction) {
                    IFunction function = (IFunction)object;
                    function.callFunction(runtime, this, new Object[0]);    //  runtimeȂ
                }
            }
*/        
            return getObjectName() + ": " + message.toString();
        } catch (ExpException e) {
            return "";
        }
    }
    
    
}
