package jp.gr.java_conf.matsubara.expresser.type;

import java.lang.reflect.*;
import java.util.List;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.IVariable;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.*;


/**
 * JavazXgIuWFNg̃NX\܂B<br/>
 * <br/>
 * 쐬: 2005/01/16
 * 
 * @author m.matsubara
 */
public class JavaClass implements IExpObject, IFunction {
    private Class javaClass;
    
    public JavaClass(Class javaClass) {
        this.javaClass = javaClass;
    }
    
    public Field getField(String fieldName) throws NoSuchFieldException {
        return javaClass.getField(fieldName);
    }
    
    public Class getJavaClass() {
        return javaClass;
    }
    
    /**
     * VCX^X𐶐܂
     * 
     * @return ꂽCX^X
     * @throws InstantiationException
     * @throws IllegalAccessException
     */
    public Object newInstance()  throws InstantiationException, IllegalAccessException {
        return javaClass.newInstance();
    }

    /**
     * VCX^X𐶐܂
     * @param params RXgN^̃p[^
     * @return ꂽCX^X
     * @throws NoSuchMethodException
     * @throws InstantiationException
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     */
    public IExpObject newInstance(IExpObject[] params)  throws NoSuchMethodException, InstantiationException, InvocationTargetException, IllegalAccessException {
        Class[] paramTypes = JavaObjectMember.createParamTypes(params);
            
        Constructor constructor = javaClass.getConstructor(paramTypes);
        return new JavaObject(constructor.newInstance(params)); //  TODO ^ϊȂ΂ȂȂ̂ł́H
    }
    
    /*
     * IFunction̎<br/>
     * NX֐ƂČĂяoꍇ̓RXgN^Ăяo
     * 
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] params) throws ExpException {
        try {
            return newInstance(params);
        } catch (Exception e) {
            throw new ExpException(Expresser.getResString("FailureCreateObject") + " : " + javaClass.getName(), 0);
        }
    }
    
    public String toString() {
        return javaClass.toString();
    }

//  TODO ȉ_~[\bh
    public IExpObject getProperty(Integer id) throws ExpException {
        JavaObjectMember member = new JavaObjectMember(javaClass, StringToId.toString(id));
        try {
            //  TODO JavaObject̃\bhvpeBƂČĂяoꍇ̓l
            //  TODO JavaObjectMember IVariablepĂėǂlB
            IExpObject memberVal = member.getValue();
            return memberVal;
        } catch (ExpException ee) {
            return member;
        }
    }

    public void putProperty(Integer id, IExpObject value) throws ExpException {
        JavaObjectMember member = new JavaObjectMember(javaClass, StringToId.toString(id));
        member.setValue(value);
    }

    public IExpObject getProperty(int index) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public void putProperty(int index, IExpObject value) throws ExpException {
        // TODO Auto-generated method stub
        
    }

    public boolean isProperty(Integer id) throws ExpException {
        // TODO Auto-generated method stub
        return false;
    }

    public IExpObject deleteProperty(Integer id) throws ExpException {
        // TODO Auto-generated method stub
        return null;
    }

    public List getConstructorList() {
        // TODO Auto-generated method stub
        return null;
    }

    public IVariable getVariable(Integer id) {
        // TODO Auto-generated method stub
        return null;
    }

    public IVariable getVariable(int Index) {
        // TODO Auto-generated method stub
        return null;
    }

    public boolean isProperty(Integer id, boolean searchPrototype) throws ExpException {
        // TODO Auto-generated method stub
        return false;
    }

    public Integer[] enumProperty() {
        // TODO Auto-generated method stub
        return null;
    }
}
