package jp.gr.java_conf.matsubara.expresser.type.property;

import jp.gr.java_conf.matsubara.expresser.Expresser;
import jp.gr.java_conf.matsubara.expresser.ITypeConverter;
import jp.gr.java_conf.matsubara.expresser.RuntimeData;
import jp.gr.java_conf.matsubara.expresser.StringToId;
import jp.gr.java_conf.matsubara.expresser.exception.ExpException;
import jp.gr.java_conf.matsubara.expresser.type.ExpFunctionBase;
import jp.gr.java_conf.matsubara.expresser.type.IExpObject;


/**
 * Global^ writeln() \bhłB<br/>
 * ̃\bhECMA262Kiɂ͂܂<br/>
 * <br/>
 * 쐬: 2005/07/24
 * 
 * @author m.matsubara
 */

public class Global__writeln extends ExpFunctionBase {
    public static final Integer ID = StringToId.toId("writeln");
    private static IExpObject instance = null; 
    
    /**
     * ̌^̐ɂ getInstance() gpĂB
     *
     */
    private Global__writeln() throws ExpException {
        super("writeln", 1);
    }

    /* ( Javadoc)
     * @see jp.gr.java_conf.matsubara.expresser.type.IFunction#callFunction(jp.gr.java_conf.matsubara.expresser.RuntimeData, java.lang.Object, java.lang.Object[])
     */
    public IExpObject callFunction(RuntimeData runtime, IExpObject thisObject, IExpObject[] arguments)
            throws ExpException {
        int max = arguments.length;
        ITypeConverter typeConverter = runtime.getTypeConverter();
        for (int idx = 0; idx < max; idx++) {
            if (arguments[idx] != null) {
                Object object = typeConverter.toString(runtime, arguments[idx]);
                runtime.getStdout().print(object);
            } else {
                runtime.getStdout().print("(null)");
            }
        }
        runtime.getStdout().println();
        return Expresser.UNDEFINED;
    }

    /**
     * B̃CX^XԂ܂B
     * @return IExpObject ^̃CX^X
     */
    public static IExpObject getInstance() throws ExpException {
        if (instance == null)
            instance = new Global__writeln();
        return instance;
    }
}
